using Microsoft.Extensions.Configuration;

namespace HKCardManager
{
    internal static class Program
    {
        /// <summary>
        ///  The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            // To customize application configuration such as set high DPI settings or default font,
            // see https://aka.ms/applicationconfiguration.
            ApplicationConfiguration.Initialize();
#if !DEBUG
            var configer = (new ConfigurationBuilder()).AddJsonFile("options.json").Build();
#else
            var configer = (new ConfigurationBuilder()).AddJsonFile("options.pro.json").Build();
#endif
            HKLib.Configer.SaasRoute = configer["SaasRoute"];
            HKLib.Configer.MqAddress = configer["MQ"];
            HKLib.Configer.TenantId = configer["TenantId"];
            HKLib.Configer.AdRoute = configer["AdRoute"];
            HKLib.Configer.Admin = configer.GetSection("Admin").GetChildren().Select(t => t.Value).ToList();
            Application.Run(new Form1());
        }
    }
}